import { Event } from "@hmans/event";
export interface IEntity {
    [key: string]: any;
}
export declare type EntityWith<E, P extends keyof E> = E & {
    [K in P]-?: E[K];
};
export declare type EntityPredicate<E, D extends E> = (entity: E) => entity is D;
export declare class Bucket<E extends IEntity> {
    [Symbol.iterator](): IterableIterator<E>;
    entities: E[];
    onEntityAdded: Event<E>;
    onEntityRemoved: Event<E>;
    onEntityTouched: Event<E>;
    derivedBuckets: WeakMap<object, any>;
    has(entity: E): boolean;
    add(entity: E): E;
    touch(entity: E): E;
    remove(entity: E): void;
    clear(): void;
    derive<D extends E = E>(predicate?: ((entity: E) => entity is D) | ((entity: E) => boolean)): Bucket<D>;
}
